/****************************************************************************/
/*																			*/
/*	Application:	QuickDraw FX											*/
/*																			*/
/*	Description:															*/
/*																			*/
/*	File:			FX.h													*/
/*																			*/
/*	Files:			FX.													*/
/*					FX..rsrc												*/
/*					FX.h													*/
/*					events.c												*/
/*					main.c													*/
/*					menu.c													*/
/*																			*/
/*	Programmer:		Edgar Lee												*/
/*	Organization:	Apple Computer, Inc. 1992								*/
/*	Department:		Developer Technical Support, DTS						*/
/*	Language:		C (Think C version 5.0.2)								*/
/*	Date Created:	5-26-92													*/
/*																			*/
/****************************************************************************/

#define		numTItems		8
#define		numAItems		8
#define		numCItems		4
#define		numMItems		3
#define		numDItems		2
#define		numBItems		3
#define		numPItems		2
#define		numLItems		2

enum {
	transferID = 1,
	arithmeticID,
	ditherID,
	colorizationID,
	searchProcID,
	paintBucketID,
	lassoID,
	pixelAverageID,
	customID
};

typedef	struct {
	Str255	label;
	Rect	rect;
} itemType;

typedef struct {
	int		tItem;
	int		aItem;
	int		cItem;
	int		mItem;
	int		dItem;
	int		bItem;
	int		pItem;
	int		lItem;
} itemSettings;

extern	WindowPtr		gWindow;
extern	GWorldPtr		gGWorld;
extern	int				gCurrentExample;
extern	itemSettings	settings;

extern	itemType	tItem[numTItems];
extern	itemType	aItem[numAItems];
extern	itemType	cItem[numCItems];
extern	itemType	dItem[numDItems];
extern	itemType	mItem[numMItems];
extern	itemType	bItem[numBItems];
extern	itemType	pItem[numPItems];
extern	itemType	lItem[numLItems];

void initMac();
void resetItems();
void createWindow();
void createOffscreen();
void defineItems();
void updateWindow();
void drawBackground();
void drawAllItems();
void drawSourceImage();
long drawFXImage();

void drawTransferItems();
void drawArithmeticItems();
void drawColorizeItems();
void drawDitherItems();
void drawMappingItems();
void drawDestinationItems();
void drawPaintBucketItems();
void drawLassoToolItems();

void drawExampleName();
void drawTime();

void drawName();
void drawItem();

void eventLoop();

void setUpMenus();
void adjustMenus();
void setMenuItem();
void handleMenu();
